;
; ff5_core.asm
;    Core improvements revision 1.7
;

incsrc ff5_labels.inc
incsrc ff5_core_config.inc

;--------------------------------
; Usꍇł\郁bZ[W
;--------------------------------
org FILEPOS_MAGMES_INFO
    db MAGMES_INFO_0X>>8, MAGMES_INFO_0X
    db MAGMES_INFO_1X>>8, MAGMES_INFO_1X
    db MAGMES_INFO_2X>>8, MAGMES_INFO_2X
    db MAGMES_INFO_3X>>8, MAGMES_INFO_3X
    db MAGMES_INFO_4X>>8, MAGMES_INFO_4X
    db MAGMES_INFO_5X>>8, MAGMES_INFO_5X
    db MAGMES_INFO_6X>>8, MAGMES_INFO_6X
    db MAGMES_INFO_7X>>8, MAGMES_INFO_7X

;--------------------------------
; ̍Uɕ\郁bZ[W
;--------------------------------
org FILEPOS_MAGMES_ALLY
    db MAGMES_ALLY_0X>>8, MAGMES_ALLY_0X
    db MAGMES_ALLY_1X>>8, MAGMES_ALLY_1X
    db MAGMES_ALLY_2X>>8, MAGMES_ALLY_2X
    db MAGMES_ALLY_3X>>8, MAGMES_ALLY_3X
    db MAGMES_ALLY_4X>>8, MAGMES_ALLY_4X
    db MAGMES_ALLY_5X>>8, MAGMES_ALLY_5X
    db MAGMES_ALLY_6X>>8, MAGMES_ALLY_6X
    db MAGMES_ALLY_7X>>8, MAGMES_ALLY_7X

;--------------------------------
; G̍Uɕ\郁bZ[W
;--------------------------------
org FILEPOS_MAGMES_ENEMY
    db MAGMES_ENEMY_0X>>8, MAGMES_ENEMY_0X
    db MAGMES_ENEMY_1X>>8, MAGMES_ENEMY_1X
    db MAGMES_ENEMY_2X>>8, MAGMES_ENEMY_2X
    db MAGMES_ENEMY_3X>>8, MAGMES_ENEMY_3X
    db MAGMES_ENEMY_4X>>8, MAGMES_ENEMY_4X
    db MAGMES_ENEMY_5X>>8, MAGMES_ENEMY_5X
    db MAGMES_ENEMY_6X>>8, MAGMES_ENEMY_6X
    db MAGMES_ENEMY_7X>>8, MAGMES_ENEMY_7X

;--------------------------------
; 퓬vO
;--------------------------------
org $C20003
BATTLE_MAIN:
    PHP
    REP #$30
    PHB
    PHD
    PHA
    PHX
    PHY
    SEP #$20
    JSR $0053       ; e탌WX^
    JSR BATTLE_INIT
    STZ $7CD8       ; 퓬ZbgtO (1: ON)

.reset
    JSR $4CE0       ; 퓬Jn
    TDC
    STA $002100     ; Screen Display
    STA $00420C     ; HDMA Enable
    STA $00420B     ; DMA Enable
    STA $004200     ; Interrupt Enable Flags
    LDA $7CD8       ; 퓬ZbgtO (1: ON)
    BNE .reset

    SEI
    JSR $0053       ; e탌WX^
    REP #$30
    PLY
    PLX
    PLA
    PLD
    PLB
    PLP
    RTL

                    ; /* org $C2003C */
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP

;--------------------------------
; e탌WX^
;--------------------------------
org $C20053
INIT_BATTLE_REGS:
    LDX #$0000
    PHX
    PLD
    TDC
    STA $004200     ; Interrupt Enable Flags
    LDA #$80        ; #$80 = Force Blank
    STA $002100     ; Screen Display
    TDC
    LDA #$7E
    PHA
    PLB
    RTS

;--------------------------------
; 퓬vṎ
;--------------------------------
org $C24F0A
INIT_BATTLE_RAM:
    LDX #$0067      ; (Init $0000`$0067)

.init_temp
    STZ $00,X
    DEX
    BPL .init_temp

    LDX #$5CD4      ; (Init $2000`$7CD4)

.init_global
    STZ $2000,X
    DEX
    BPL .init_global

    TXA             ; A = 0xFF
    STX $41A9       ; ̃^[sł閡̔ԍ[0]
    STX $41AB       ; ̃^[sł閡̔ԍ[2]
    STA $41AD       ; ̃^[sł閡̔ԍ[4]
    STA $41CC       ; ݍs̖LN^̔ԍ
    STA $7C4B       ; X^[̔ԍ
    LDX #$01FF      ; (Init $384C`$3A4B = 0xFF)

.init_action_script
    STA $384C,X     ; sXNvg[0]
    DEX
    BPL .init_action_script

    LDX #$001F

.set_battle_flags
    LDA $09B4,X     ; @̃vgp
    STA $7C74,X     ; @̃vgp
    DEX
    BPL .set_battle_flags

    LDA $0AFB       ; ^C}[JEg邩ǂ (0: OFF, 2: ON)
    STA $7C94       ; ^C}[JEg邩ǂ (0: OFF, 2: ON)
    LDX $0AFC       ; ^C}[c莞
    STX $7C95       ; ^C}[c莞
    LDX $7CD5       ; (l)()
    STX $0947       ; ()
    LDA $7CD7       ; (l)()
    STA $0949       ; ()
    INC $7C72
    RTS

BATTLE_INIT:
    LDX $09C0       ; 퓬
    CPX #$FFFF
    BEQ .battle_count_max

    INX
    STX $09C0       ; 퓬

.battle_count_max
    LDX $0947       ; ()
    STX $7CD5       ; (l)()
    LDA $0949       ; ()
    STA $7CD7       ; (l)()
    RTS

    NOP : NOP : NOP : NOP
    NOP

;--------------------------------
; SLN^̏p[^ݒ
;--------------------------------
org $C2515C
INIT_CHARACTER_PARAM:
    TDC
    TAY
    TAX

.begin
    LDA $0502,Y     ; x
    STA $2002,X     ; x
    STZ $2022,X     ; p[Abv

    REP #$20
    LDA $0524,Y     ; (␳Ȃ) / f(␳Ȃ)
    STA $2024,X     ; (␳Ȃ) / f(␳Ȃ)
    LDA $0526,Y     ; ̗(␳Ȃ) / (␳Ȃ)
    STA $2026,X     ; ̗(␳Ȃ) / (␳Ȃ)

    LDA $0508,Y     ; őqbg|Cg
    STA $2008,X     ; őqbg|Cg
    CMP $2006,X     ; qbg|Cg
    BCS .hp_normal_range

    STA $2006,X     ; qbg|Cg

.hp_normal_range
    STZ $201E,X     ; Clear ԕω5 & UCtO
    STZ $2030,X     ; Clear z & 𑮐
    STZ $2032,X     ; Clear  & 
    STZ $2034,X     ; Clear _ & ԕωϐ1
    STZ $2036,X     ; Clear ԕωϐ2 & ԕωϐ3
    STZ $2038,X     ; Clear ʃtO

    TYA
    CLC
    ADC #$0050
    TAY
    TDC
    SEP #$20
    JSR $01E0       ; XWX^ += 0x80 (̃LN^)
    CPX #$0200
    BNE .begin

    RTS

    NOP : NOP : NOP

;--------------------------------
; ACe̎/ 0 ̃ACeNA
;--------------------------------
; /* org $C251AB */
REMOVE_ZEROITEM:
    LDX #$00FF

.begin
    LDA $0640,X     ; ACe
    BEQ .clear_item_c

    LDA $0740,X     ; ACe
    BNE .continue

.clear_item_t
    STZ $0640,X     ; ACe

.clear_item_c
    STZ $0740,X     ; ACe

.continue
    DEX
    BPL .begin

    RTS

;--------------------------------
; Replace 'JSL $D0EF78' with 'JSR REMOVE_ZEROITEM'
;--------------------------------
org $C24246
    JSR REMOVE_ZEROITEM : NOP

org $C2511C
    JSR REMOVE_ZEROITEM : NOP

;--------------------------------
; 퓬̌ʂ]
;--------------------------------
org $C251F4
TRANSFER_BATTLE_RESULT:
    TDC
    TAX
    LDY #$7C1A      ; LN^ԍ(bit0-3: ԍ | 20: , 40: E,
                    ; 80: ) (l)
    STY $10
    TAY

.begin
    STZ $201B,X     ; Clear ԕω2(ꎞI)
    STZ $201C,X     ; Clear ԕω3(⏕@)
    STZ $201D,X     ; Clear ԕω4
    STZ $201E,X     ; Clear ԕω5
    NOP : NOP : NOP ; /* reapply_item_immunity: STZ $2035,X */
    NOP : NOP : NOP ; /* reapply_item_immunity: STZ $2036,X */
    NOP : NOP : NOP ; /* reapply_item_immunity: STZ $2037,X */

    LDA ($10)
    STA $2000,X     ; LN^ԍ(bit0-3: ԍ | 20: , 40: E,
                    ; 80: )
    LDA #$46
    STA $0E

.move_params
    LDA $2000,X     ; LN^ԍ(bit0-3: ԍ | 20: , 40: E,
                    ; 80: )
    STA $0500,Y     ; LN^ԍ(bit0-3: ԍ | 20: , 40: E,
                    ; 80: )
    INX
    INY
    DEC $0E
    BNE .move_params

    REP #$21
    TYA
    ADC.w #$0050-$0046
    TAY
    TXA
    ADC.w #$0080-$0046
    TAX
    TDC
    SEP #$20
    INC $10         ; (ʃoCgɂ͉eȂ 8 bit accum ŃCN
                    ; g)
    CPX #$0200
    BNE .begin

    LDX #$00FF

.move_items
    LDA $2734,X     ; ACe
    STA $0640,X     ; ACe
    BEQ .set_empty

    LDA $2834,X     ; ACe

.set_empty
    STA $0740,X     ; ACe
    BNE .next_item

    STA $0640,X     ; ACe

.next_item
    DEX
    BPL .move_items

    REP #$21
    LDA $094A       ; vC()
    ADC $DB6E       ; 퓬̌oߎ()
    STA $094A       ; vC()
    LDA $094C       ; vC()
    ADC $DB70       ; 퓬̌oߎ()
    STA $094C       ; vC()
    BCC .time_normal_range

    LDA #$FFFF
    STA $094A       ; vC()
    STA $094C       ; vC()

.time_normal_range
    TDC
    SEP #$20
    RTS

                    ; /* org $C25276 */
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP

;--------------------------------
; 8 Ԗڂ̃X^[ΏۂɎwł悤ɏC
;--------------------------------
org $C29510
FIX_EIGHTH_MONSTER:
    CPY #$000D      ; <- CPY #$000C

;--------------------------------
; ŏɍsłLN^肷鏈̊ԈႢC
;--------------------------------
org $C24F01
FIX_ATB_INIT:
    NOP
    NOP
    NOP
    CPX #$0200

;--------------------------------
; GX^[\͒l㏸̂̂ꍇ̏C
;--------------------------------
org $C2234C
FIX_SONG:
    LDX #$0200      ; <- LDX #$0180

;--------------------------------
; X^[p[eB̕ŏʃoCg̒l𐳊mɃ`FbN悤ɏC
;--------------------------------
org $C20B2C
THROW_IF_SANDWORM:
    LDX $04F0       ; X^[p[eB̎
    CPX #$01BF
    BEQ .sandworm

    LDX $32         ; AhXւ̃CfbNX
    LDA $0E
    STA $2058,X     ; s̑Ώ(G)
    BRA $0B46

.sandworm
    LDX $32         ; AhXւ̃CfbNX
    LDA $0E
    AND #$FC
    STA $2058,X     ; s̑Ώ(G)

org $C23EDF
POISON_IF_MAGISSA:
    LDX $04F0       ; X^[p[eB̎
    CPX #$01BA
    BEQ $3EEB
    BRA $3F11

org $C2569A
ITEM_DROP_IF_SANDWORM:
    LDX $04F0       ; X^[p[eB̎
    CPX #$01BF
    BNE $56A7
    RTS

;--------------------------------
; X^[̍ő}WbN|Cgݒ肷
;--------------------------------
org $C23FE0
INIT_MONSTER_MAXMP:
    REP #$20
    LDA $3F09,X     ; MONDATA[10]: }WbN|Cg
    CMP $220C,Y     ; ő}WbN|Cg (= 9999)
    BCC .minimum_mp

    STA $220C,Y     ; ő}WbN|Cg

.minimum_mp
    BIT $3F18,X     ; (Check bit7 of MONDATA[26])
    BPL .not_permanence

    TYA
    CLC
    ADC #$0056
    TAY

.not_permanence
    LDA $3F19,X     ; MONDATA[26]: ŏKpԕω1
    AND #$FF7F
    STA $221A,Y     ; ԕω1(iI) / ԕω2(ꎞI)
    LDA $3F1B,X     ; MONDATA[28]: ŏKpԕω3
    STA $221C,Y     ; ԕω3(⏕@) / ԕω4
    TDC
    SEP #$20

;--------------------------------
; X^[̖Oݒ肷
;--------------------------------
org $C2400A
INIT_MONSTER_NAME:
    LDA $12
    ASL
    TAY
    LDA $3F1D,X     ; MONDATA[30]: X^[̖O
    STA $4008,Y     ; X^[̖O()
    LDA $4021,Y     ; X^[ԍ()
    CMP #$FF
    BEQ .is_empty   ; (Set X^[̖O = 0x00FF)

    STA $4009,Y     ; X^[̖O()

.is_empty
    REP #$20
    LDA $4020,Y     ; X^[ԍ()
    ASL
    TAX
    TDC

;--------------------------------
; \郂X^[̖O肷
;--------------------------------
org $C25A8C
LOAD_MONSTER_NAME:
    REP #$20
    LDA $4008,X     ; X^[̖O
    CMP $0E
    BEQ .inc_same_monster

    INY
    INY
    INY
    INY
    STA $4038,Y     ; 1Ԗڂ̃X^[̖O
    STA $0E
    NOP

.inc_same_monster:
    TDC
    SEP #$20
    CLC
    LDA $403A,Y     ; 1Ԗڂ̃X^[̐
    ADC #$01
    STA $403A,Y     ; 1Ԗڂ̃X^[̐

;--------------------------------
; X^[̃p[^ǂ̃AhXǂݍނ
;--------------------------------
org $C24D5E
INIT_MONSTER_PARAM:
    TDC
    TAX
    STX $10

org $C24D62
.begin
    ASL
    TAY
    LDA $4021,Y     ; X^[ԍ()
    BEQ .normal     ; X^[ԍ 0x00FF ȉȂʏ탂X^[

    INC             ; X^[ԍ 0xFF00 ȏȂʏ탂X^[
    BNE .boss       ; X^[ԍ 0x0100 ȏȂ{XX^[

.normal
    LDA.b #FILEPOS_MONDATA1>>16
    LDY.w #FILEPOS_MONDATA1
    BRA .assign_address

.boss
    LDA.b #FILEPOS_MONDATA2>>16
    LDY.w #FILEPOS_MONDATA2

.assign_address
    STA $14
    STY $12

org $C24DA1
    BNE .begin

;--------------------------------
; From $C29427: ̔p^[ݒ肷 | UtOݒ肷
;--------------------------------
org $C29761
SET_COMMAND_RESULT:
    JSR $9885       ; ̔p^[ݒ肷
    LDA $7B2C       ; U(ݒl)
    TAX
    LDA $D0EE85,X   ; ($3BCC: s) ւ̃CfbNX: 0, 7, 14, 21, 28,
                    ; 35, 42, 49, 56, 63, 70, 77, 84, 91, 98, 105
    TAY
    STZ $0E         ; (Reset flags)
    LDA $4747       ; : @̔ԍ
    CMP #$81        ; #$81 = "Ƃ킴"
    BNE .unset_specialty

    LDA #$01        ; (Set monster specialty)
    TSB $0E

.unset_specialty
    LDA $7BFB       ; UtO (0: s, 0ȊO: sȂ)
    BEQ .unset_no_action

    LDA #$20        ; (Set no action)
    TSB $0E

.unset_no_action
    LDA $7C5D       ; (uꂢvŎgp)
    BEQ .unset_alt_palette

    LDA #$02        ; (Set alternate palette?)
    TSB $0E

.unset_alt_palette
    LDA $47         ; ̔ԍ(0`3: , 4`: G)
    CMP #$04
    BCC .unset_monster

    SBC #$04
    TAX
    LDA #$80        ; (Set monster action)
    TSB $0E
    TXA

.unset_monster
    STA $3BCD,Y     ; s: UsLN^̔ԍ
    LDA $7B45       ; ̔ԍ (u΂vɂď㏑)
    TAX
    CMP #$04
    BCC .unset_attack_to_monster

    SBC #$04
    TAX
    LDA #$40        ; (Set attack to monster side)
    TSB $0E

.unset_attack_to_monster
    LDA $3BCE,Y     ; s: UڕW
    JSR $01D6       ; AWX^̒l(7 - XWX^)rbgZbg
    STA $3BCE,Y     ; s: UڕW
    LDA $5F         ; UGtFNg(NeBJ)
    ORA $61         ; UGtFNg(@NeBJ)
    BEQ .unset_flash

    LDA #$10        ; (Set flash)
    TSB $0E

.unset_flash
    LDA $7B40       ; Ũ_[Wh䂵
    BEQ .unset_no_damage

    LDA #$08        ; (Set no damage sound)
    TSB $0E

.unset_no_damage
    LDA $0E         ; (Get flags)
    STA $3BCC,Y     ; s: tO
    LDA $7B46       ; utNvAj[V
    BNE .reflected

    LDA $3BCF,Y     ; s: ۂɍU󂯂LN^
    ORA $7B41       ; UڕWrbg
    STA $3BCF,Y     ; s: ۂɍU󂯂LN^
    BRA .check_target

.reflected
    LDA $7B45       ; ̔ԍ (u΂vɂď㏑)
    STA $48         ; ̔ԍ(0`3: , 4`: G)
    LDA $3BD0,Y     ; s: utNvŔ˂LN^
    ORA $7B42       ; utNvŔ˂LN^
    STA $3BD0,Y     ; s: utNvŔ˂LN^
    LDA $7B41       ; UڕWrbg
    BEQ .check_target

    LDA $7B2C       ; U(ݒl)
    JSR $01B6       ; 8{
    STA $0F
    LDA $48         ; ̔ԍ(0`3: , 4`: G)
    CMP #$04
    BCC .reflected_to_ally

    SBC #$04

.reflected_to_ally
    CLC
    ADC $0F
    TAX
    LDA $7B43       ; utNv̔ˑΏ
    STA $7B49,X
    LDA $3BD1,Y     ; s: utNv̔ˑΏ
    ORA $7B43       ; utNv̔ˑΏ
    STA $3BD1,Y     ; s: utNv̔ˑΏ

.check_target
    LDA $7B44       ; (u΂vŎgp)
    STA $3BD2,Y     ; s: u΂vΏۂ̃LN^
    LDA $7B2C       ; U(ݒl)
    TAX
    LDA $7B1C,X     ; UΏۂ̐
    BEQ .end_of_command

    INC $7ABC       ; UΏۂ̐(ݒl)
    CMP $7ABC       ; UΏۂ̐(ݒl)
    BNE .next_target

.end_of_command
    LDA $3BCF,Y     ; s: ۂɍU󂯂LN^
    BNE .target_specific_message

.no_targets_hit
    LDA.b #FILEPOS_MAGMES_INFO>>16
    LDY.w #FILEPOS_MAGMES_INFO
    BRA .clear_battle_message

    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP

.target_specific_message
    LDA $3BCC,Y     ; s: tO
                    ; (if monster action)
    BPL .attack_from_ally

.attack_from_enemy
    LDA.b #FILEPOS_MAGMES_ENEMY>>16
    LDY.w #FILEPOS_MAGMES_ENEMY
    BRA .clear_battle_message

.attack_from_ally
    LDA.b #FILEPOS_MAGMES_ALLY>>16
    LDY.w #FILEPOS_MAGMES_ALLY

.clear_battle_message
    STY $10
    STA $12
    JSR $9965       ; bZ[Wւ̃CfbNXZbg (X: ԍ,
                    ; Y: p[^)
    LDA $3C5F,X     ; bZ[W̕\ԍ
    TAY
    AND #$07
    TAX
    TYA
    LSR
    LSR
    LSR
    TAY
    LDA [$10],Y
    JSR $01DB       ; AWX^̒l(7 - XWX^)rbgZbgĂ
                    ; ꍇ0NA
    BNE .next_command

    JSR $9965       ; bZ[Wւ̃CfbNXZbg (X: ԍ,
                    ; Y: p[^)
    TDC
    STA $3C5F,X     ; bZ[W

.next_command
    INC $7B2C       ; U(ݒl)
    INC $79FB       ; U (_[W|Cgp)
    STZ $7ABC       ; UΏۂ̐(ݒl)
    STZ $7C08       ; }WbN|Cgǂ (1: ON)

.next_target
    RTS

;--------------------------------
; Xg[J[ 0xFF () 𖳎
;--------------------------------
org $C2758C
FIX_STALKER_PROCESS:
    JSR $01EC       ; XWX^($32: AhXւ̃CfbNX) =
                    ; AWX^~128
    LDA $201D,X     ; ԕω4 (01: , 02: m, 04: ̂Ă,
                    ; 08: Xbv, 10: ̐鍐, 20: ], 40: U,
                    ; 80: E)
    AND #$BF
    STA $201D,X     ; ԕω4 (01: , 02: m, 04: ̂Ă,
                    ; 08: Xbv, 10: ̐鍐, 20: ], 40: U,
                    ; 80: E)
    REP #$20
    TDC
    DEC
    STA $0E         ; $0E = 0xFFFF
    TDC
    TAY
    TAX

.set_lowest_hp
    LDA $4020,Y     ; X^[ԍ
    CMP #$FFFF
    BEQ .continue

    LDA $2206,X     ; qbg|Cg
    CMP $0E
    BCS .continue

    STA $0E

.continue
    CLC
    TXA
    ADC #$0080
    TAX
    INY
    INY
    CPX #$0200
    BNE .set_lowest_hp

;--------------------------------
;  MP Z
;--------------------------------
org $C26766
MP_ADDITION_SELF:
    LDX $7B73       ; MP񕜗
    BMI $679E       ; Skip if $7B73 is 0xFFFF

    LDA $47         ; ̔ԍ(0`3: , 4`: G)
    JSR $685C       ; XWX^ = \_[W/񕜒lւ̃CfbNX
                    ; (AWX^: Ώ, $26: ItZbg)
    REP #$21
    LDA $7B73       ; MP񕜗
    ORA #$8000
    STA $3A4C,X     ; _[W\l (8000: , 4000: ~X)
    NOP
    NOP
    NOP
    NOP
    LDA $7B73       ; MP񕜗
    AND #$3FFF
    STA $0E
    LDX $32         ; AhXւ̃CfbNX
    LDA $200A,X     ; }WbN|Cg
    ADC $0E
    BCS .mp_overflow

    CMP $200C,X     ; ő}WbN|Cg
    BCC .mp_normal_range

.mp_overflow
    LDA $200C,X     ; ő}WbN|Cg

.mp_normal_range
    STA $200A,X     ; }WbN|Cg
    TDC
    SEP #$20

;--------------------------------
;  MP Z
;--------------------------------
org $C2679E
MP_ADDITION_TARGET:
    LDX $7B75       ; MP񕜗
    BMI $67E0       ; Skip if $7B75 is 0xFFFF

    LDA $7C61       ; ̔ԍ ($48) ̑ ($7C60) g
    BEQ .get_target_no

    LDA $7C60       ; ̔ԍ ($7C61)
    BRA .do_addition

.get_target_no
    LDA $48         ; ̔ԍ(0`3: , 4`: G)

.do_addition
    JSR $685C       ; XWX^ = \_[W/񕜒lւ̃CfbNX
                    ; (AWX^: Ώ, $26: ItZbg)
    REP #$21
    LDA $7B75       ; MP񕜗
    ORA #$8000
    STA $3A4C,X     ; _[W\l (8000: , 4000: ~X)
    NOP
    NOP
    NOP
    NOP
    LDA $7B75       ; MP񕜗
    AND #$3FFF
    STA $0E
    LDX $49         ; AhXւ̃CfbNX
    LDA $200A,X     ; }WbN|Cg
    ADC $0E
    BCS .mp_overflow

    CMP $200C,X     ; ő}WbN|Cg
    BCC .mp_normal_range

.mp_overflow
    LDA $200C,X     ; ő}WbN|Cg

.mp_normal_range
    STA $200A,X     ; }WbN|Cg
    TDC
    SEP #$20

;--------------------------------
; SGtFNgp^[𖳌ɂ
;--------------------------------
org $C1B660
DISABLE_ALL_EFFECTS:
    SEC
    LDA #$70

.begin
    TAX
    STZ $D1D8,X     ; EFFECT[0]: Enable
    STZ $D258,X     ; EFFECT[8]: Enable
    STZ $D2D8,X     ; EFFECT[16]: Enable
    STZ $D358,X     ; EFFECT[24]: Enable
    SBC #$10
    BCS .begin

    RTS

    NOP
    NOP

;--------------------------------
; sGtFNg 00h: @U
;--------------------------------
org $C1B677
BATTLE_EFFECT_00h:
    NOP
    NOP
    NOP
    STZ $DB6B       ; 퓬j[ɏdȂGtFNg\ (1: ON)
    STZ $DB77       ; C[WX̏GtFNgݒ肷 (1: ON)
    STZ $DBDF       ; GtFNgʉoX (0: , 1: W)
    JSR $9D93       ; _[W/񕜂̕\I܂ŃEFCg
    JSR $B536       ; gp@̎ނɏ]ĔGtFNgs
    JMP BATTLE_EFFECT_07h

;--------------------------------
; sGtFNg 07h: @U (GtFNgȂ)
;--------------------------------
org $C1B68C
BATTLE_EFFECT_07h:
    JSR $9D93       ; _[W/񕜂̕\I܂ŃEFCg
    JSR $8D47       ; @̔ԍ擾
    TAX
    JMP DO_EFFECT

    NOP
    NOP
    NOP
    NOP
    NOP
    NOP

;--------------------------------
; GtFNgs (XWX^: GtFNgԍ)
;--------------------------------
org $C1B69C
DO_EFFECT:
    BRA .do_effect

    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP

;                   ; /* fast_nothing: */
;   CPX #$00AA      ; #$00AA = "Ȃ"
;   BEQ .do_nothing
;
;   CPX #$00AC      ; #$00AC = "m[_[W܂ق"
;   BEQ .do_nothing
;
;   CPX #$00EE      ; #$00EE = "X^[oԐݒ"
;   BNE .do_effect
;
;.do_nothing
;   RTS

.do_effect
    STZ $DB6A       ; tNGtFNgݒ肵 (1: ON)

.do_compound_effect
    STX $F86E       ; GtFNgԍ
    STZ $F86D       ; tN̔ˑΏۂɃGtFNgs (1: ON)
    STZ $DB6B       ; 퓬j[ɏdȂGtFNg\ (1: ON)
    STZ $DB77       ; C[WX̏GtFNgݒ肷 (1: ON)

.do_additional_effect
    INC $DB77       ; C[WX̏GtFNgݒ肷 (1: ON)
    STZ $F86A       ; AĎsGtFNg()
    STZ $F86B       ; AĎsGtFNg()
    JSR $A847       ; GtFNgf[^ݒ肷 (XWX^: GtFNgԍ)
    JSR $B300       ; X^[OtBbNĕ\ | GtFNgp
                    ; tO
    LDA $F582       ; GtFNg^Cv
    STA $D1BC       ; sGtFNg^Cv
    AND #$3F
    ASL
    TAX
    JSR ($B746,X)
    JSR DISABLE_ALL_EFFECTS
    LDX $F86A       ; AĎsGtFNg
    BNE .do_compound_effect

    LDA $DB61       ; LN^\tO (01: b\)
    BEQ .not_summon

    STZ $F8B4
    LDA #$80
    STA $DB60       ; LN^\tO (01: XVȂ, 80: p[eB\
                    ; )
    JSR $02F2       ; EFCg(ʂXV)
    LDA #$10
    STA $BC85       ; Color math designation
    LDA #$1F
    JSR $B3FE       ; Fixed Color Data ̐Fx A WX^̒lɐݒ肷
    JSR $24D5       ; LN^̃OtBbNĕ\
    JSR $B40A       ; XvCg̐Fxɖ߂
    TDC
    STZ $7E
    JSR $7B43       ;

.wait_bg_reset      ; XXX: $D0EE  0 łȂꍇ̓nOAbv (sv?)
    JSR $02F2       ; EFCg(ʂXV)
    LDA $D0EE
    BNE .wait_bg_reset

    LDX $F86E       ; GtFNgԍ
    CPX #$0068      ; #$0068 = "r[̂Ђ"
    BNE .not_summon

    LDX #$0000
    STX $F86E       ; GtFNgԍ
    LDX #$001F      ; #$001F = "tN"
    BRA .do_additional_effect

.not_summon
    STZ $DB56
    LDA $F86D       ; tN̔ˑΏۂɃGtFNgs (1: ON)
    BNE .end_effect

    INC $F86D       ; tN̔ˑΏۂɃGtFNgs (1: ON)
    LDX $F86E       ; GtFNgԍ
    JSR $8D41       ; utNvŔ˂LN^擾
    BNE .do_additional_effect

.end_effect
    STZ $DBDF       ; GtFNgʉoX (0: , 1: W)
    STZ $BC85       ; Color math designation
    JSR $AD2D       ; X^[̎̐鍐̕\ݒ肷
    JSR $1CB8       ; X^[OtBbNĕ\
    JMP $3CBB       ; bZ[W

;--------------------------------
; R[h 12h: @
;--------------------------------
org $C08A85
CHAR_MAGIC_NAME:
    LDA $16A3       ; @̔ԍ
    REP #$20
    ASL
    STA $0F
    ASL
    CLC
    ADC $0F
    TAX             ; X = (@̔ԍ)~6
    LDA $06         ; $06 = 0
    SEP #$20
    STZ $09

.next_char
    LDA FILEPOS_MAGNAME,X
    CMP #$E0        ; #$E0 = icon
    BCS .continue

    STA $19D3,Y     ; R[h()
    LDA #$00
    STA $1A13,Y     ; R[h()
    INY

.continue
    INX
    INC $09
    LDA $09
    CMP #$06
    BNE .next_char

    STY $AB
    JMP $8459

;--------------------------------
; R[h 11h: ACe
;--------------------------------
org $C08AB7
CHAR_ITEM_NAME:
    LDA $16A2       ; ACe̔ԍ
    REP #$20
    STA $0F
    ASL
    ASL
    ASL
    CLC
    ADC $0F
    TAX             ; X = (ACe̔ԍ)~9
    LDA $06         ; $06 = 0
    SEP #$20
    STZ $09

.next_char
    LDA FILEPOS_ITEMNAME,X
    CMP #$E0        ; #$E0 = icon
    BCS .continue

    STA $19D3,Y     ; R[h()
    LDA #$00
    STA $1A13,Y     ; R[h()
    INY

.continue
    INX
    INC $09
    LDA $09
    CMP #$09
    BNE .next_char

    STY $AB
    JMP $8459

;--------------------------------
; R[h 10h: l
;--------------------------------
org $C08AEA
CHAR_INTEGER:
    STZ $0C         ; (ŏ̌)
    LDX $06         ; $06 = 0

.next_num
    LDA $0C         ; (ŏ̌)
    BNE .num_found

    LDA $10AD,X
    BEQ .continue

    INC $0C         ; (ŏ̌)

.num_found
    LDA $10AD,X
    CLC
    ADC #$53        ; #$53 = "0"
    STA $19D3,Y     ; R[h()
    LDA #$00
    STA $1A13,Y     ; R[h()
    INY

.continue
    INX
    CPX #$0007
    BNE .next_num

    STY $AB
    JMP $8459

;--------------------------------
; 퓬OtBbN̏
;--------------------------------
org $C10888
INIT_BATTLE_GFX:

org $C1095E
    LDA #$7E
    PHA
    PLB
    LDX #$283E      ; (Init $7EB3B7`$7EDBF5)

.init_1
    STZ $B3B7,X
    DEX
    BPL .init_1

    LDX #$008A      ; (Init $7E0070`$7E00FA)

.init_2
    STZ $0070,X
    DEX
    BPL .init_2

    TDC
    LDX #$01FF      ; (Init $7E7E09`$7E8008)

.init_3
    STA $7E09,X
    DEX
    BPL .init_3

    LDX #$0FFF      ; (Init $7EDCF6`$7EECF5)

.init_4
    STA $DCF6,X
    DEX
    BPL .init_4

    LDX #$005F      ; (Init $7EF789`$7EF7E8)

.init_image
    STZ $F789,X     ; Ōɕ\g
    DEX
    BPL .init_image

;--------------------------------
; 󔠉\
;--------------------------------
org $C12EBF
GET_TREASURES_LOOTED:
    TDC
    TAX
    STZ $7E         ; 󔠂̐

.begin
    LDA #$08
    STA $80
    LDA $09D4,X     ; 肵󔠃tO

.get_bit
    ASL
    BCC .not_obtained

    INC $7E         ; 󔠂̐

.not_obtained
    DEC $80
    BNE .get_bit

    INX
    CPX #$0020
    BNE .begin

    STZ $7F
    LDX #$0064
    STX $80
    JSR $FE67       ; Z(16bit) (($7E)~($80) = ($82: 32bit))
    LDX $82
    STX $7E
    LDX #TREASURES_TOTAL
    STX $80
    JSR $FDE7       ; Z(16bit) (($7E)($80) = ($82) ] ($84))
    LDX $82         ; 󔠉
    BRA $2EA7

;--------------------------------
; œK
;--------------------------------
PROGRAM_OPTIMIZATION:
org $C21066
    LDA $47         ; ̔ԍ(0`3: , 4`: G)
    TAX
    LDA $D0EEDB,X   ; ($37DC: ) ւ̃CfbNX: 0, 20, 40, 60
    TAX
    TDC
    TAY
    NOP
    NOP
    NOP
    NOP
    NOP

org $C21285
    LDA $47         ; ̔ԍ(0`3: , 4`: G)
    TAX
    LDA $D0EEDB,X   ; ($37DC: ) ւ̃CfbNX: 0, 20, 40, 60
    TAX
    TDC
    TAY
    NOP
    NOP
    NOP
    NOP
    NOP

org $C219EA
    LDA $41CC       ; ݍs̖LN^̔ԍ
    ASL
    TAX
    REP #$21
    LDA $D0ED59,X   ; @AhXւ̃CfbNX: 0, 650, 1300, 1950
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    NOP
    ADC #$2D34      ; #$2D34 = 1lڂ̖@̖@ԍ
    STA $45
    TDC
    SEP #$20

org $C21A75
    LDA $41C0       ; sR}h̔ԍ
    REP #$20
    JSR $01B6       ; 8{
    TAX
    TDC
    SEP #$20
    NOP
    NOP

org $C21B0D
    LDA $41CC       ; ݍs̖LN^̔ԍ
    TAX
    LDA $D0ED85,X   ; ($4049: f[^) ւ̃CfbNX: 0, 84, 168, 252
    TAY
    NOP
    NOP
    NOP
    NOP
    NOP

org $C21BBE
    LDA $41CC       ; ݍs̖LN^̔ԍ
    TAX
    LDA $D0ED85,X   ; ($4049: f[^) ւ̃CfbNX: 0, 84, 168, 252
    TAY
    NOP
    NOP
    NOP
    NOP
    NOP

org $C21EA8
    LDA $3D         ; ݏ̖LN^̔ԍ
    ASL
    TAX
    REP #$20
    LDA $D0ED59,X   ; @AhXւ̃CfbNX: 0, 650, 1300, 1950
    TAX
    TDC
    SEP #$20
    NOP

org $C24056
    LDA $12
    ASL
    TAX
    REP #$20
    LDA $D0EEA5,X   ; 0, 1620, 3240, 4860, 6480, 8100, 9720, 11340
    TAX
    TDC
    SEP #$20

org $C293B5
    LDA $47         ; ̔ԍ(0`3: , 4`: G)
    TAX
    LDA $D0EEDB,X   ; ($37DC: ) ւ̃CfbNX: 0, 20, 40, 60
    TAX
    TDC
    TAY
    NOP
    NOP
    NOP
    NOP
    NOP

org $C29F42
    LDA $41CC       ; ݍs̖LN^̔ԍ
    PHX
    TAX
    LDA $CEFF84,X   ; ($37AC: ݒ) ւ̃CfbNX: 0, 12, 24, 36
    TAY
    PLX
    NOP
    NOP

;--------------------------------
; Get 16-bit digit strings (src: X, dest: $C4)
;--------------------------------
org $C1FF2E
GET_16BIT_DIGIT:
    PHY
    REP #$20
    TXA
    SEP #$11
    LDY $CE         ; digit_chr
    DEY
    STY $7E         ; (digit_chr - 1)

.count_thousands
    SBC #$03E8
    INY
    BCS .count_thousands

    ADC #$03E8      ; (set carry)
    STY $C4         ; digit[0]
    LDY $7E         ; (digit_chr - 1)

.count_hundreds
    SBC #$0064
    INY
    BCS .count_hundreds

    ADC #$0064      ; (set carry)
    STY $C5         ; digit[1]
    LDY $7E         ; (digit_chr - 1)
    SEP #$20

.count_tens
    SBC #$0A
    INY
    BCS .count_tens

    STY $C6         ; digit[2]
    ADC #$0A        ; (set carry)
    ADC $7E         ; (digit_chr - 1)
    STA $C7         ; digit[3]
    REP #$10
    PLY
    RTS

    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP

;--------------------------------
; Get 24-bit digit strings (src: $70, dest: $C4)
;--------------------------------
org $C1FF88
GET_24BIT_DIGIT:
    PHY
    TDC
    TAX
    TAY
    STZ $73

.begin
    REP #$20
    SEC
    STZ $78         ; digit_number

.count
    LDA $70
    SBC $D97D09,X   ; 10000000, 1000000, 100000, 10000, 1000, 100, 10
    STA $74
    LDA $72
    SBC $D97D0B,X   ; 10000000, 1000000, 100000, 10000, 1000, 100, 10
    BCC .break

    STA $72
    LDA $74
    STA $70
    INC $78         ; digit_number
    BRA .count

.break
    SEP #$20
    LDA $78         ; digit_number
    ADC $CE         ; digit_chr
    STA $00C4,Y     ; digit[0]
    INY
    INX
    INX
    INX
    INX
    CPY #$0007
    BNE .begin

    LDA $70
    CLC
    ADC $CE         ; digit_chr
    STA $CB         ; digit[7]
    PLY
    TDC
    RTS

    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP
